﻿#pragma strict

var WIDTH = 450;
var HEIGHT = 300;
public class Point {
  var x : float;
  var y : float;
}
public class Motion {
  var dx : float;
  var dy : float;
}
var rescue : Point;
var target : Point;
var direction : Motion;
var radarRange : float;
var targetObject : GameObject; 
var rescueObject : GameObject;
var cameraObject : GameObject;



function Start () {
  targetObject = GameObject.Find("boat");
  rescueObject = GameObject.Find("spotlight");
  cameraObject = GameObject.Find("Main Camera");
  rescue.x = WIDTH / 2;
  rescue.y = HEIGHT / 2;
  target.x = WIDTH * Random.value;
  target.y = HEIGHT * Random.value;
  direction.dx = 1;
  direction.dy = 1;
  radarRange = 30;
}

function Update () {
  if(found()) {
    target.x = WIDTH * Random.value;
    target.y = HEIGHT * Random.value;
  }
  drawTarget();
  drawRescue();
  moveCamera();
  if (xBoundary()) direction.dx = -direction.dx;
  if (yBoundary()) direction.dy = -direction.dy;
  rescue.x += direction.dx;
  rescue.y += direction.dy;
}

function toTarget()
{
        return Mathf.Sqrt(Mathf.Pow(Mathf.Abs(target.x - rescue.x), 2) + Mathf.Pow(Mathf.Abs(target.y - rescue.y), 2));
}

function found()
{
        return toTarget()  <= radarRange;
}

function xBoundary()
{
        return (rescue.x <= radarRange) || (rescue.x >= WIDTH - radarRange);
}

function yBoundary()
{
        return (rescue.y <= radarRange) || (rescue.y >= HEIGHT - radarRange);
}

function moveCamera() {
  cameraObject.transform.position = Vector3(rescue.x - 50 * direction.dx, 10, rescue.y - 50 * direction.dy);
  cameraObject.transform.LookAt(rescueObject.transform);
}

function drawTarget() {
  Debug.Log("Target is at " + target.x + " " + target.y);
  targetObject.transform.position = Vector3(target.x, 0, target.y);
}

function drawRescue() {
  rescueObject.transform.position = Vector3(rescue.x, 0, rescue.y);
}
